Index: /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/Algorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/Algorithm.cs	(revision 4455)
+++ /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/Algorithm.cs	(revision 4455)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class Algorithm : NamedOKBItem {
+    [DataMember]
+    public long PlatformId { get; set; }
+    [DataMember]
+    public long AlgorithmClassId { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/AlgorithmClass.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/AlgorithmClass.cs	(revision 4455)
+++ /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/AlgorithmClass.cs	(revision 4455)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class AlgorithmClass : NamedOKBItem { }
+}
Index: /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/HeuristicLab.Services.OKB.DataTransfer-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/HeuristicLab.Services.OKB.DataTransfer-3.3.csproj	(revision 4455)
+++ /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/HeuristicLab.Services.OKB.DataTransfer-3.3.csproj	(revision 4455)
@@ -0,0 +1,77 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Services.OKB.DataTransfer</RootNamespace>
+    <AssemblyName>HeuristicLab.Services.OKB.DataTransfer-3.3</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <TargetFrameworkProfile />
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Runtime.Serialization" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="AlgorithmClass.cs" />
+    <Compile Include="Algorithm.cs" />
+    <Compile Include="NamedOKBItem.cs" />
+    <Compile Include="OKBItem.cs" />
+    <Compile Include="Platform.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <None Include="Properties\AssemblyInfo.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/NamedOKBItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/NamedOKBItem.cs	(revision 4455)
+++ /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/NamedOKBItem.cs	(revision 4455)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public abstract class NamedOKBItem : OKBItem {
+    [DataMember]
+    public string Name { get; set; }
+    [DataMember]
+    public string Description { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/OKBItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/OKBItem.cs	(revision 4455)
+++ /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/OKBItem.cs	(revision 4455)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public abstract class OKBItem {
+    [DataMember]
+    public long Id { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/Platform.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/Platform.cs	(revision 4455)
+++ /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/Platform.cs	(revision 4455)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class Platform : NamedOKBItem { }
+}
Index: /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/Properties/AssemblyInfo.frame
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/Properties/AssemblyInfo.frame	(revision 4455)
+++ /trunk/sources/HeuristicLab.Services.OKB.DataTransfer/3.3/Properties/AssemblyInfo.frame	(revision 4455)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Services.OKB.DataTransfer")]
+[assembly: AssemblyDescription("Data transfer objects for HeuristicLab OKB services")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2010 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("73fea41e-7023-483f-abc1-0c1a6894a1fb")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.0.$WCREV$")]
Index: /trunk/sources/HeuristicLab.Services.OKB/3.3/AdminService.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB/3.3/AdminService.cs	(revision 4454)
+++ /trunk/sources/HeuristicLab.Services.OKB/3.3/AdminService.cs	(revision 4455)
@@ -21,5 +21,4 @@
 
 using System.Collections.Generic;
-using System.Data.Linq;
 using System.Linq;
 using System.ServiceModel;
@@ -28,41 +27,32 @@
 namespace HeuristicLab.Services.OKB {
   /// <summary>
-  /// Implementation of <see cref="IAdminService"/>
+  /// Implementation of the OKB administration service (interface <see cref="IAdminService"/>).
   /// </summary>
   [ServiceBehavior(IncludeExceptionDetailInFaults = true)]
   public class AdminService : IAdminService {
     #region Platform Methods
-    public Platform GetPlatform(long platformId) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return okb.Platforms.FirstOrDefault(p => p.Id == platformId);
-      }
-    }
-    public IEnumerable<Platform> GetPlatforms() {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return okb.Platforms.ToArray();
-      }
-    }
-    public void StorePlatform(Platform platform) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        Platform original = okb.Platforms.FirstOrDefault(p => p.Id == platform.Id);
-        if (original == null) {
-          okb.Platforms.InsertOnSubmit(new Platform() {
-            Name = platform.Name,
-            Description = platform.Description
-          });
-        } else {
-          original.Name = platform.Name;
-          original.Description = platform.Description;
-        }
-        okb.SubmitChanges();
-      }
-    }
-    public void DeletePlatform(long platformId) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        Platform platform = okb.Platforms.FirstOrDefault(p => p.Id == platformId);
-        if (platform != null) {
-          okb.Platforms.DeleteOnSubmit(platform);
-          okb.SubmitChanges();
-        }
+    public DataTransfer.Platform GetPlatform(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return Convert.ToDto(okb.Platforms.FirstOrDefault(x => x.Id == id));
+      }
+    }
+    public IEnumerable<DataTransfer.Platform> GetPlatforms() {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return okb.Platforms.Select(x => Convert.ToDto(x)).ToArray();
+      }
+    }
+    public void StorePlatform(DataTransfer.Platform dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Platform entity = okb.Platforms.FirstOrDefault(x => x.Id == dto.Id);
+        if (entity == null) okb.Platforms.InsertOnSubmit(Convert.ToEntity(dto));
+        else Convert.ToEntity(dto, entity);
+        okb.SubmitChanges();
+      }
+    }
+    public void DeletePlatform(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Platform entity = okb.Platforms.FirstOrDefault(x => x.Id == id);
+        if (entity != null) okb.Platforms.DeleteOnSubmit(entity);
+        okb.SubmitChanges();
       }
     }
@@ -70,36 +60,27 @@
 
     #region AlgorithmClass Methods
-    public AlgorithmClass GetAlgorithmClass(long algorithmClassId) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return okb.AlgorithmClasses.FirstOrDefault(a => a.Id == algorithmClassId);
-      }
-    }
-    public IEnumerable<AlgorithmClass> GetAlgorithmClasses() {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return okb.AlgorithmClasses.ToArray();
-      }
-    }
-    public void StoreAlgorithmClass(AlgorithmClass algorithmClass) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        AlgorithmClass original = okb.AlgorithmClasses.FirstOrDefault(a => a.Id == algorithmClass.Id);
-        if (original == null) {
-          okb.AlgorithmClasses.InsertOnSubmit(new AlgorithmClass() {
-            Name = algorithmClass.Name,
-            Description = algorithmClass.Description
-          });
-        } else {
-          original.Name = algorithmClass.Name;
-          original.Description = algorithmClass.Description;
-        }
-        okb.SubmitChanges();
-      }
-    }
-    public void DeleteAlgorithmClass(long algorithmClassId) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        AlgorithmClass algorithmClass = okb.AlgorithmClasses.FirstOrDefault(a => a.Id == algorithmClassId);
-        if (algorithmClass != null) {
-          okb.AlgorithmClasses.DeleteOnSubmit(algorithmClass);
-          okb.SubmitChanges();
-        }
+    public DataTransfer.AlgorithmClass GetAlgorithmClass(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return Convert.ToDto(okb.AlgorithmClasses.FirstOrDefault(x => x.Id == id));
+      }
+    }
+    public IEnumerable<DataTransfer.AlgorithmClass> GetAlgorithmClasses() {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return okb.AlgorithmClasses.Select(x => Convert.ToDto(x)).ToArray();
+      }
+    }
+    public void StoreAlgorithmClass(DataTransfer.AlgorithmClass dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.AlgorithmClass entity = okb.AlgorithmClasses.FirstOrDefault(x => x.Id == dto.Id);
+        if (entity == null) okb.AlgorithmClasses.InsertOnSubmit(Convert.ToEntity(dto));
+        else Convert.ToEntity(dto, entity);
+        okb.SubmitChanges();
+      }
+    }
+    public void DeleteAlgorithmClass(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.AlgorithmClass entity = okb.AlgorithmClasses.FirstOrDefault(x => x.Id == id);
+        if (entity != null) okb.AlgorithmClasses.DeleteOnSubmit(entity);
+        okb.SubmitChanges();
       }
     }
@@ -107,43 +88,32 @@
 
     #region Algorithm Methods
-    public Algorithm GetAlgorithm(long algorithmId) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return okb.Algorithms.FirstOrDefault(a => a.Id == algorithmId);
-      }
-    }
-    public IEnumerable<Algorithm> GetAlgorithms() {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        return okb.Algorithms.ToArray();
-      }
-    }
-    public void StoreAlgorithm(Algorithm algorithm) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        Algorithm original = okb.Algorithms.FirstOrDefault(a => a.Id == algorithm.Id);
-        if (original == null) {
-          okb.Algorithms.InsertOnSubmit(new Algorithm() {
-            Name = algorithm.Name,
-            Description = algorithm.Description,
-            PlatformId = algorithm.PlatformId,
-            AlgorithmClassId = algorithm.AlgorithmClassId
-          });
-        } else {
-          original.Name = algorithm.Name;
-          original.Description = algorithm.Description;
-          original.PlatformId = algorithm.PlatformId;
-          original.AlgorithmClassId = algorithm.AlgorithmClassId;
-        }
-        okb.SubmitChanges();
-      }
-    }
-    public void DeleteAlgorithm(long algorithmId) {
-      using (OKBDataContext okb = new OKBDataContext()) {
-        Algorithm algorithm = okb.Algorithms.FirstOrDefault(a => a.Id == algorithmId);
-        if (algorithm != null) {
-          okb.Algorithms.DeleteOnSubmit(algorithm);
-          okb.SubmitChanges();
-        }
+    public DataTransfer.Algorithm GetAlgorithm(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return Convert.ToDto(okb.Algorithms.FirstOrDefault(x => x.Id == id));
+      }
+    }
+    public IEnumerable<DataTransfer.Algorithm> GetAlgorithms() {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        return okb.Algorithms.Select(x => Convert.ToDto(x)).ToArray();
+      }
+    }
+    public void StoreAlgorithm(DataTransfer.Algorithm dto) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Algorithm entity = okb.Algorithms.FirstOrDefault(x => x.Id == dto.Id);
+        if (entity == null) okb.Algorithms.InsertOnSubmit(Convert.ToEntity(dto));
+        else Convert.ToEntity(dto, entity);
+        okb.SubmitChanges();
+      }
+    }
+    public void DeleteAlgorithm(long id) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataAccess.Algorithm entity = okb.Algorithms.FirstOrDefault(x => x.Id == id);
+        if (entity != null) okb.Algorithms.DeleteOnSubmit(entity);
+        okb.SubmitChanges();
       }
     }
     #endregion
+
+    /*
 
     /// <summary>
@@ -274,5 +244,5 @@
         });
       }
-    }
+    }*/
   }
 }
Index: /trunk/sources/HeuristicLab.Services.OKB/3.3/Convert.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB/3.3/Convert.cs	(revision 4455)
+++ /trunk/sources/HeuristicLab.Services.OKB/3.3/Convert.cs	(revision 4455)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using DA = HeuristicLab.Services.OKB.DataAccess;
+using DT = HeuristicLab.Services.OKB.DataTransfer;
+
+namespace HeuristicLab.Services.OKB {
+  public static class Convert {
+    #region Platform
+    public static DT.Platform ToDto(DA.Platform source) {
+      return new DT.Platform { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static DA.Platform ToEntity(DT.Platform source) {
+      return new DA.Platform { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static void ToEntity(DT.Platform source, DA.Platform target) {
+      target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
+    }
+    #endregion
+
+    #region AlgorithmClass
+    public static DT.AlgorithmClass ToDto(DA.AlgorithmClass source) {
+      return new DT.AlgorithmClass { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static DA.AlgorithmClass ToEntity(DT.AlgorithmClass source) {
+      return new DA.AlgorithmClass { Id = source.Id, Name = source.Name, Description = source.Description };
+    }
+    public static void ToEntity(DT.AlgorithmClass source, DA.AlgorithmClass target) {
+      target.Id = source.Id; target.Name = source.Name; target.Description = source.Description;
+    }
+    #endregion
+
+    #region Algorithm
+    public static DT.Algorithm ToDto(DA.Algorithm source) {
+      return new DT.Algorithm { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, AlgorithmClassId = source.AlgorithmClassId };
+    }
+    public static DA.Algorithm ToEntity(DT.Algorithm source) {
+      return new DA.Algorithm { Id = source.Id, Name = source.Name, Description = source.Description, PlatformId = source.PlatformId, AlgorithmClassId = source.AlgorithmClassId };
+    }
+    public static void ToEntity(DT.Algorithm source, DA.Algorithm target) {
+      target.Id = source.Id; target.Name = source.Name; target.Description = source.Description; target.PlatformId = source.PlatformId; target.AlgorithmClassId = source.AlgorithmClassId;
+    }
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 4454)
+++ /trunk/sources/HeuristicLab.Services.OKB/3.3/HeuristicLab.Services.OKB-3.3.csproj	(revision 4455)
@@ -121,9 +121,12 @@
   <ItemGroup>
     <Compile Include="AdminService.cs" />
+    <Compile Include="Convert.cs" />
     <Compile Include="Interfaces\IAdminService.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
   <ItemGroup>
-    <None Include="app.config" />
+    <None Include="app.config">
+      <SubType>Designer</SubType>
+    </None>
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
@@ -133,4 +136,8 @@
       <Project>{E36BE58F-F3CE-40BB-9AB3-9F9E30AD5CCF}</Project>
       <Name>HeuristicLab.Services.OKB.DataAccess-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Services.OKB.DataTransfer\3.3\HeuristicLab.Services.OKB.DataTransfer-3.3.csproj">
+      <Project>{209FD7A1-DFB2-4B9F-9268-B95E886B2F7A}</Project>
+      <Name>HeuristicLab.Services.OKB.DataTransfer-3.3</Name>
     </ProjectReference>
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.Services.OKB/3.3/Interfaces/IAdminService.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.OKB/3.3/Interfaces/IAdminService.cs	(revision 4454)
+++ /trunk/sources/HeuristicLab.Services.OKB/3.3/Interfaces/IAdminService.cs	(revision 4455)
@@ -23,110 +23,38 @@
 using System.Net.Security;
 using System.ServiceModel;
-using HeuristicLab.Services.OKB.DataAccess;
+using HeuristicLab.Services.OKB.DataTransfer;
 
 namespace HeuristicLab.Services.OKB {
   /// <summary>
-  /// Service of administrating the OKB.
-  /// </summary>  
+  /// Interface of the OKB administration service.
+  /// </summary>
   [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
   public interface IAdminService {
     [OperationContract]
-    Platform GetPlatform(long platformId);
+    Platform GetPlatform(long id);
     [OperationContract]
     IEnumerable<Platform> GetPlatforms();
     [OperationContract]
-    void StorePlatform(Platform platform);
+    void StorePlatform(Platform dto);
     [OperationContract]
-    void DeletePlatform(long platformId);
+    void DeletePlatform(long id);
 
     [OperationContract]
-    AlgorithmClass GetAlgorithmClass(long algorithmClassId);
+    AlgorithmClass GetAlgorithmClass(long id);
     [OperationContract]
     IEnumerable<AlgorithmClass> GetAlgorithmClasses();
     [OperationContract]
-    void StoreAlgorithmClass(AlgorithmClass algorithmClass);
+    void StoreAlgorithmClass(AlgorithmClass dto);
     [OperationContract]
-    void DeleteAlgorithmClass(long algorithmClassId);
+    void DeleteAlgorithmClass(long id);
 
     [OperationContract]
-    Algorithm GetAlgorithm(long algorithmId);
+    Algorithm GetAlgorithm(long id);
     [OperationContract]
     IEnumerable<Algorithm> GetAlgorithms();
     [OperationContract]
-    void StoreAlgorithm(Algorithm algorithm);
+    void StoreAlgorithm(Algorithm dto);
     [OperationContract]
-    void DeleteAlgorithm(long algorithmId);
-
-
-
-    /// <summary>
-    /// Gets the complete algorithm object graph up to the following entities:
-    /// <list type="bullet">
-    /// <item>Parameter</item>
-    /// <item>Algorithm_Paramters.Parameter.DataType</item>
-    /// <item>Algorithm_Results.Result.DataType</item>
-    /// </list>
-    /// </summary>
-    /// <param name="id">The algorithm id.</param>
-    /// <returns>An <see cref="Algorithm"/></returns>
-    [OperationContract]
-    Algorithm GetCompleteAlgorithm(int id);
-
-    /// <summary>
-    /// Gets the complete problem object graph up to the following entities:
-    /// <list type="bullet">
-    /// <item>Platform</item>
-    /// <item>SolutionRepresentation</item>
-    /// <item>Problem_Parameters.Parameter</item>
-    /// <item>IntProblemCharacteristicValues.ProblemCharacteristic.DataType</item>
-    /// <item>FloatProblemCharacteristicValues.ProblemCharacteristic.DataType</item>
-    /// <item>CharProblemCharacteristicValues.ProblemCharacteristic.DataType</item>
-    /// </list>
-    /// </summary>
-    /// <param name="id">The problem id.</param>
-    /// <returns>A <see cref="Problem"/></returns>
-    [OperationContract]
-    Problem GetCompleteProblem(int id);
-
-    /// <summary>
-    /// Updates the algorithm object graph including the following properties and linked entitites:
-    /// <list type="bullet">
-    /// <item>Name</item>
-    /// <item>Description</item>
-    /// <item>AlgorithmClassId</item>
-    /// <item>PlatformId</item>
-    /// <item>Algorithm_Parameters</item>
-    /// <item>Algorithm_Results</item>
-    /// </list>
-    /// <remarks>
-    /// New <see cref="Parameter"/>s or <see cref="Result"/>s will not be
-    /// created but have to be pre-existing.
-    /// </remarks>
-    /// </summary>
-    /// <param name="algorithm">The algorithm.</param>
-    [OperationContract]
-    void UpdateCompleteAlgorithm(Algorithm algorithm);
-
-    /// <summary>
-    /// Updates the problem object graph including the following properties and linked entities:
-    /// <list type="bullet">
-    /// <item>Name</item>
-    /// <item>Description</item>
-    /// <item>ProblemClassId</item>
-    /// <item>PlatformId</item>
-    /// <item>SolutionRepresentationId</item>
-    /// <item>IntProblemCharacteristicValues.Value</item>
-    /// <item>FloatProblemCharacteristicValues.Value</item>
-    /// <item>CharProblemCharacteristicValues.Value</item>
-    /// <item>Problem_Parameters</item>
-    /// </list>
-    /// <remarks>
-    /// New <see cref="ProblemCharacteristic"/>s or <see cref="Parameter"/>s will
-    /// not be created but have to be pre-existing.
-    /// </remarks>
-    /// </summary>
-    /// <param name="problem">The problem.</param>
-    [OperationContract]
-    void UpdateCompleteProblem(Problem problem);
+    void DeleteAlgorithm(long id);
   }
 }
